"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StateProcessor = void 0;
const jsonpath_plus_1 = require("jsonpath-plus");
class StateProcessor {
    static processInputPath(dataJson, inputPath) {
        if (inputPath === null) {
            return '{}';
        }
        const inputJson = dataJson || '{}';
        const result = jsonpath_plus_1.JSONPath({
            path: inputPath === undefined ? '$' : inputPath,
            json: JSON.parse(inputJson),
        });
        if (!result || result.length === 0) {
            throw new Error('');
        }
        return JSON.stringify(result[0]);
    }
    static processResultPath(json, resultPath) {
        const result = jsonpath_plus_1.JSONPath({
            path: resultPath || '$',
            json: JSON.parse(json),
        });
        if (!result || result.length === 0) {
            throw new Error('');
        }
        return JSON.stringify(result[0]);
    }
    static processOutputPath(json, outputPath) {
        const result = jsonpath_plus_1.JSONPath({
            path: outputPath || '$',
            json: JSON.parse(json),
        });
        if (!result || result.length === 0) {
            throw new Error('');
        }
        return JSON.stringify(result[0]);
    }
}
exports.StateProcessor = StateProcessor;
