"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TaskExecutor = void 0;
const fs_1 = require("fs");
const path_1 = __importDefault(require("path"));
const StateInfoHandler_1 = require("../StateInfoHandler");
const StateProcessor_1 = require("../StateProcessor");
class TaskExecutor {
    async execute(stateMachineName, stateName, stateDefinition, inputJson) {
        const statesInfoHandler = StateInfoHandler_1.StateInfoHandler.getInstance();
        const stateInfo = statesInfoHandler.getStateInfo(stateMachineName, stateName);
        if (!stateInfo) {
            throw new Error('Handler does not exists');
        }
        // TODO: Handle Lambda Context and Callback
        const input = this.processInput(inputJson, stateDefinition);
        const context = {};
        const lambdaPath = await this.getWebpackOrCommonFuction(stateInfo.handlerPath);
        const functionLambda = await Promise.resolve().then(() => __importStar(require(`${lambdaPath}`)));
        const output = await functionLambda[stateInfo.handlerName](input, context);
        const outputJson = this.processOutput(output, stateDefinition);
        return outputJson;
    }
    processInput(json, stateDefinition) {
        const proccessedInputJson = StateProcessor_1.StateProcessor.processInputPath(json, stateDefinition.InputPath);
        // TODO: Parameters Task
        return JSON.parse(proccessedInputJson);
    }
    processOutput(output, stateDefinition) {
        let outputJson = output ? JSON.stringify(output) : '{}';
        // TODO: Do Result Selector
        outputJson = StateProcessor_1.StateProcessor.processResultPath(outputJson, stateDefinition.ResultPath);
        outputJson = StateProcessor_1.StateProcessor.processOutputPath(outputJson, stateDefinition.OutputPath);
        return outputJson;
    }
    async getWebpackOrCommonFuction(lambdaFilePath) {
        const webpackPath = path_1.default.resolve(process.cwd(), `./.webpack/service/${lambdaFilePath}.js`);
        let filePathResolved;
        try {
            await fs_1.promises.access(webpackPath, fs_1.constants.F_OK | fs_1.constants.R_OK);
            filePathResolved = webpackPath;
        }
        catch (error) {
            filePathResolved = `./${lambdaFilePath}`;
        }
        return filePathResolved;
    }
}
exports.TaskExecutor = TaskExecutor;
