"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PassExecutor = void 0;
const StateProcessor_1 = require("../../StateProcessor");
const Logger_1 = require("../../utils/Logger");
class PassExecutor {
    constructor() {
        this.logger = Logger_1.Logger.getInstance();
    }
    execute(_stateMachineName, stateName, definition, json) {
        this.logger.log(`* * * Passed Task ${stateName} * * *`);
        const input = this.processInput(json, definition);
        return Promise.resolve({
            Next: definition.Next,
            End: definition.End,
            json: this.processOutput(input, definition),
        });
    }
    processInput(json, stateDefinition) {
        const proccessedInputJson = StateProcessor_1.StateProcessor.processInputPath(json, stateDefinition.InputPath);
        return proccessedInputJson;
    }
    processOutput(output, stateDefinition) {
        let outputJson = output || '{}';
        outputJson = StateProcessor_1.StateProcessor.processResultPath(outputJson, stateDefinition.ResultPath);
        outputJson = StateProcessor_1.StateProcessor.processOutputPath(outputJson, stateDefinition.OutputPath);
        return outputJson;
    }
}
exports.PassExecutor = PassExecutor;
